import { ChangeDetectorRef, DoCheck, ElementRef } from '@angular/core';
import { ControlValueAccessor, FormGroupDirective, NgControl, NgForm } from '@angular/forms';
import { CanDisable, CanDisableCtor, CanUpdateErrorState, CanUpdateErrorStateCtor, ErrorStateMatcher, HasTabIndex, HasTabIndexCtor } from '@angular/material/core';
import { SimpleDecimal } from '../../models/decimal.model';
import { Direction } from '../../models/direction.enum';
import { DeviceService } from '../../services/device/device.service';
import { LanguageService } from '../../services/language/language.service';
import { SpinnerKeyManager } from '../a11y/key-manager/spinner-key-manager';
export declare const BUFFER_TIMEOUT = 250;
export declare const TIMEOUT = 50;
declare class SimpleSpinnerBase {
    _elementRef: ElementRef;
    _defaultErrorStateMatcher: ErrorStateMatcher;
    _parentForm: NgForm;
    _parentFormGroup: FormGroupDirective;
    ngControl: NgControl;
    constructor(_elementRef: ElementRef, _defaultErrorStateMatcher: ErrorStateMatcher, _parentForm: NgForm, _parentFormGroup: FormGroupDirective, ngControl: NgControl);
}
declare const _SimpleSpinnerMixinBase: CanDisableCtor & HasTabIndexCtor & CanUpdateErrorStateCtor & typeof SimpleSpinnerBase;
export declare class SpinnerComponent extends _SimpleSpinnerMixinBase implements ControlValueAccessor, DoCheck, CanDisable, HasTabIndex, CanUpdateErrorState {
    device: DeviceService;
    ngControl: NgControl;
    private cdRef;
    private langService;
    placeholder?: string;
    dir?: 'ltr' | 'rtl' | 'auto';
    errorStateMatcher: ErrorStateMatcher;
    private _ariaLabel?;
    get id(): string;
    set id(id: string);
    get value(): number;
    set value(value: number);
    get min(): number;
    set min(min: number);
    get max(): number;
    set max(max: number);
    get hoverBorder(): boolean;
    set hoverBorder(hoverBorder: boolean);
    get hoverNav(): boolean;
    set hoverNav(hoverNav: boolean);
    get fractions(): boolean;
    set fractions(fractions: boolean);
    get i18nNumbers(): boolean;
    set i18nNumbers(i18nNumbers: boolean);
    get bigStep(): number;
    set bigStep(bigStep: number);
    get smallStep(): number;
    set smallStep(smallStep: number);
    get maxDecimalPlaces(): number;
    set maxDecimalPlaces(maxDecimalPlaces: number);
    get required(): boolean;
    set required(required: boolean);
    get direction(): Direction;
    get showBorder(): boolean;
    get showNav(): boolean;
    get showFractionOverlay(): boolean;
    get showPlaceholder(): boolean;
    get ariaLabel(): string | null;
    numberInput: ElementRef;
    decimal: SimpleDecimal;
    keyManager: SpinnerKeyManager;
    hover: boolean;
    focus: boolean;
    intervalHandler: any;
    filterKeyRegex: RegExp;
    Direction: typeof Direction;
    private _id;
    private _min;
    private _max;
    private _hoverBorder;
    private _hoverNav;
    private _fractions;
    private _i18nNumbers;
    private _bigStep;
    private _smallStep;
    private _maxDecimalPlaces;
    private _required;
    private uid;
    constructor(device: DeviceService, elementRef: ElementRef, _defaultErrorStateMatcher: ErrorStateMatcher, _parentForm: NgForm, _parentFormGroup: FormGroupDirective, ngControl: NgControl, tabIndex: string, cdRef: ChangeDetectorRef, langService: LanguageService);
    propagateChange: (_: any) => void;
    propagateTouched: () => void;
    checkValue(): void;
    filterKey(event: KeyboardEvent): void;
    increment(): void;
    decrement(): void;
    add(once?: boolean): void;
    subtract(once?: boolean): void;
    startCount(callback: () => void): void;
    stopCount(): void;
    mouseenter(): void;
    mouseleave(): void;
    focusInput(): void;
    changeInput(): void;
    blurInput(): void;
    writeValue(value: number): void;
    registerOnChange(fn: () => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState?(isDisabled: boolean): void;
    ngDoCheck(): void;
}
export {};
