declare global {
    interface Number {
        toFixedNoRounding: (fractionDigits?: number) => number;
    }
}
export declare enum Round {
    up = 0,
    down = 1
}
export declare class SimpleDecimal {
    private _value;
    private _maxDecimalPlacesFn;
    private _integerPart;
    private _dividend;
    private _divisor;
    get integerPart(): number;
    get decimalPart(): number;
    get dividend(): number;
    get divisor(): number;
    get decimalPlaces(): number;
    get value(): number;
    set value(value: number);
    get maxDecimalPlaces(): number;
    get hasPrettyFraction(): boolean;
    get precedingStr(): string;
    get dividendStr(): string;
    get divisorStr(): string;
    constructor(maxDecimalPlaces: (() => number) | number, value?: number);
    toString(): string;
    add(i: number): SimpleDecimal;
    sub(i: number): SimpleDecimal;
    toNearest(multiple: number, roundMode?: Round): number;
    private calculateFraction;
}
